﻿# ******************************************************
# *
# * Name:         make-storage-n-audit.ps1
# *     
# * Design Phase:
# *     Author:   John Miner
# *     Date:     11-29-2017
# *     Purpose:  Create blob storage and define a
# *               database audit
# * 
# ******************************************************

#
# Azure Subscriptions 
#

# Prompts you for azure credentials
Add-AzureRmAccount

# Clear the screen
Clear-Host

# List my subscriptions
Get-AzureRmSubscription

# Pick my MSDN one
Set-AzureRmContext -SubscriptionId 'cdfb69bf-3533-4c89-9684-1ba6ba81b226'



#
# Create a storage account
#

# Create new storage account 
New-AzureRmStorageAccount –StorageAccountName "sa4tips17" `
  -ResourceGroupName "rg4tips17"  -Location "East US" `
  -Type "Standard_LRS" 

# Show the account
Get-AzureRmStorageAccount -ResourceGroupName "rg4tips17"

# Delete storage account
# Remove-AzureRmStorageAccount -ResourceGroupName "rg4tips17" -Name "sa4tips17"


#
# View current database auditing
#

# Clear the screen
Clear-Host

# Show database auditing
Get-AzureRmSqlDatabaseAuditing `
  -ServerName "mssqltips17" `
  -DatabaseName "hippa" `
  -ResourceGroupName "rg4tips17"


#
# Enable database auditing
#

# Clear the screen
Clear-Host

# Enable auditing (has to be Generic storage)
Set-AzureRmSqlDatabaseAuditing `
    -State Enabled `
    -ResourceGroupName "rg4tips17" `
    -ServerName "mssqltips17" `
    -StorageAccountName "sa4tips17" `
    -DatabaseName "hippa"


#
# Disable database auditing
#

# Clear the screen
Clear-Host

# Enable auditing (has to be Generic storage)
Set-AzureRmSqlDatabaseAuditing `
    -State Disable `
    -ResourceGroupName "rg4tips17" `
    -ServerName "mssqltips17" `
    -StorageAccountName "sa4tips17" `
    -DatabaseName "hippa"


# Remove database auditing
Remove-AzureRmSqlDatabaseAuditing `
    -ResourceGroupName "rg4tips17" `
    -ServerName "mssqltips17" `
    -StorageAccountName "sa4tips17" `
    -DatabaseName "hippa"

  <#
-AuditActionGroup `
     'SUCCESSFUL_DATABASE_AUTHENTICATION_GROUP' `
    ,'FAILED_DATABASE_AUTHENTICATION_GROUP' `
    ,'DATABASE_OBJECT_CHANGE_GROUP' `
  -AuditAction 'SELECT, INSERT, UPDATE, DELETE ON dbo.Salaries BY public'

DatabaseName       : hippa
AuditAction        : {}
AuditActionGroup   : {SUCCESSFUL_DATABASE_AUTHENTICATION_GROUP, FAILED_DATABASE_AUTHENTICATION_GROUP, BATCH_COMPLETED_GROUP}
ResourceGroupName  : rg4steward17
ServerName         : sql4steward17
AuditState         : Enabled
StorageAccountName : sa4steward17
StorageKeyType     : Primary
RetentionInDays    : 0


#>

